function [H,R] = ichol0_ikj(A)
%
% Incomplete Choleski factorization (without pivoting), 
% ikj version, didactic purpose
% row-contiguos data structure (C, C++)
%
% A = H'*H-R
%

% no extra storage needed
n = length(A);
R = spalloc(n,n,n^2-nnz(A));
for i = 2:n
  for k = 1:i-1
    A(i,k) = A(i,k)/A(k,k);
    for j = k+1:n
      if (A(i,j) ~= 0)
	A(i,j) = A(i,j)-A(i,k)*A(k,j); % i-th row is changed
      else
	R(i,j) = R(i,j)+A(i,k)*A(k,j);
      end
    end
  end
end
% the matrix A now contains exactly U in the triu part and L (except the
% ones on the diagonal) on the tril part
H = triu(A);
% now we scale the matrices
H = diag(sqrt(diag(H))) \ H;