function [L,U] = lu_ikj(A)
%
% LU factorization (without pivoting), ikj version, didactic purpose
% row-contiguos data structure (C, C++)
%
% A = L*U

% no extra storage needed
n = length(A);
for i = 2:n
  for k = 1:i-1
    A(i,k) = A(i,k)/A(k,k);
    for j = k+1:n
      A(i,j) = A(i,j)-A(i,k)*A(k,j); % i-th row is changed
    end
  end
end
% the matrix A now contains exactly U in the triu part and L (except the
% ones on the diagonal) on the tril part
U = triu(A);
L = A-U+eye(size(A));